#ifndef _MODBUS_C
#define _MODBUS_C

#include <stdio.h>
#include <string.h>
#include <iom128.h>
#include "modbus.h" 



//ܺ Լ    
extern void GLCD_string(unsigned char x, unsigned char y, char *string);


//---------------ش MCU ´ 1byte  Լ---------------// 
void MB_ByteSend(unsigned char data){
  while(!(UCSR1A & (1<<UDRE1)));	UDR1 = data;
}

//---------------ش MCU ´ rs485   Լ---------------// 
#define MB_RS485_CTR      PORTD_Bit0	
void MB_RS485Ctr(unsigned char val){
  if(val){ 
    ;//MB_RS485_CTR = 1; 
  }else{ 
    ;//MB_RS485_CTR = 0; 
  } 
}

//---------------Ÿ Ž ó ƾ---------------//  
void MBR_DataSet(void){
  unsigned int cnt=0;
  float fBf[2]={0.0,0.0};
  int wBf[2]={0,0};
  
  //Read
  cnt=0;
  //mb_UIdata[cnt++]|=0x0001; 
  
  
  cnt=0;
  //Write
  if(mb_UIdataBu[cnt]!=mb_UIdata[cnt]){  mb_UIdataBu[cnt]=mb_UIdata[cnt];   
    fBf[0]=(float)mb_UIdata[cnt];  fBf[0] /= 10.0;
    memcpy(wBf,fBf,8);  mb_UIdata[cnt]=wBf[0];  mb_UIdata[cnt+1]=wBf[1];   //memcpy(mb_UIdata,fBf,(4*1));  
    //if(mb_WriteUIdata[cnt]==0) mb_UCdata[0]=0x00;
    //else mb_UCdata[0]=0x03;
    
    char sbf[10];
    sprintf(sbf,"%d",mb_UIdata[cnt]);  GLCD_string(0, 0, sbf);
    sprintf(sbf,"%d",mb_UIdata[cnt+1]);  GLCD_string(0, 2, sbf);
    if(mb_UIdataBu[cnt]==0) GLCD_string(0, 0, "000");  else  GLCD_string(0, 0, "xxx");     
    if(mb_UIdataBu[cnt]==0) mb_UIdata[4]=1;  else  mb_UIdata[4]=2;     
    
    cnt++;  
  }  
  
  //mb_WriteUCdata[10],mb_WriteUCdataBu[10]
  cnt=0;
  if(mb_UCdataBu[cnt]!=mb_UCdata[cnt]){  mb_UCdataBu[cnt]=mb_UCdata[cnt]; 
      //if(mb_UCdata[cnt]==0) mb_UCdata[cnt]=0x02;
      //else mb_UCdata[cnt]=0;
    mb_UCdata[cnt]=mb_UCdata[cnt];
    
    if(mb_UCdata[cnt]&0x02) mb_UCdata[cnt]|=0x01;
    else mb_UCdata[cnt]&=0xFE;
  }  
  
}

//---------------  ,Ʈ  ʱȭ---------------//  
void MBR_DataInit(void){
   unsigned int cnt=4,data;
   //mb_WriteUIdataBu[cnt]=mb_WriteUIdata[cnt]=SetAirFilterHour; cnt++;  
   //data= SetRunReservationTime[0][0];  data<<=8;   data|=SetRunReservationTime[0][1];  
   //mb_WriteUIdataBu[cnt]=mb_WriteUIdata[cnt]=data; cnt++;  //Ͽ 
  

}


//-----------------------------------------------------------------------------------------------------------------
unsigned char ComId=MB_ADR;
int mb_UIdata[MB_WordDataSPACE],mb_UIdataBu[MB_WordDataSPACE];
unsigned char mb_UCdata[MB_BitDataSPACE],mb_UCdataBu[MB_BitDataSPACE];
unsigned char mbTickEvt=0;
unsigned int mbRxCnt=0;
unsigned char mbRxData[MB_RxDataMAX];
unsigned char mbframecprcnt=250,mbframecprevent=0;
unsigned char mb485CtrCnt=0,mbrs485CtrState=0;
unsigned char crcbf1,crcbf2;
const unsigned char BitOnVal[8] = { 0x01, 0x02, 0x04,0x08, 0x10, 0x20, 0x40, 0x80 };

// CRC15-IBM
const unsigned char auchCRCHi[]  =  {
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,0x40};

const unsigned char auchCRCLo[] = {
0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 0x07, 0xC7, 0x05, 0xC5, 0xC4,
0x04, 0xCC, 0x0C, 0x0D, 0xCD, 0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A, 0x1E, 0xDE, 0xDF, 0x1F, 0xDD,
0x1D, 0x1C, 0xDC, 0x14, 0xD4, 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 0xF2, 0x32, 0x36, 0xF6, 0xF7,
0x37, 0xF5, 0x35, 0x34, 0xF4, 0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29, 0xEB, 0x2B, 0x2A, 0xEA, 0xEE,
0x2E, 0x2F, 0xEF, 0x2D, 0xED, 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 0x61, 0xA1, 0x63, 0xA3, 0xA2,
0x62, 0x66, 0xA6, 0xA7, 0x67, 0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68, 0x78, 0xB8, 0xB9, 0x79, 0xBB,
0x7B, 0x7A, 0xBA, 0xBE, 0x7E, 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 0x70, 0xB0, 0x50, 0x90, 0x91,
0x51, 0x93, 0x53, 0x52, 0x92, 0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B, 0x99, 0x59, 0x58, 0x98, 0x88,
0x48, 0x49, 0x89, 0x4B, 0x8B, 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 0x43, 0x83, 0x41, 0x81, 0x80,0x40};


unsigned char RcvGetCRC(unsigned char *pby,unsigned char lenth, unsigned char hi, unsigned char low){
  unsigned char Index,i,CRCHi=0xff,CRCLo=0xff,rtdata=0;
  for(i=0;i<lenth;i++){
    Index=CRCHi^*pby++;      CRCHi=CRCLo^auchCRCHi[Index];      CRCLo=auchCRCLo[Index];
  }
  if((hi==CRCHi)&&(low==CRCLo)) rtdata=1;
  else rtdata=0; 
  return rtdata;
}
void GetCRC(unsigned char* pby,unsigned char lenth, unsigned char* hi, unsigned char* low){
  unsigned char Index,i,CRCHi=0xff,CRCLo=0xff; 
  for(i=0;i<lenth;i++){
    Index=CRCHi^*pby++;   CRCHi=CRCLo^auchCRCHi[Index];    CRCLo=auchCRCLo[Index];
  }
  *hi=CRCHi; *low=CRCLo;
}

void Rs485Ctr(char cpr){
  if(cpr){  mbrs485CtrState=1;   MB_RS485Ctr(1);   }
  else{  mb485CtrCnt=0;  }
}

// Bit
void MBR_F1_BitRead(void){
  unsigned char mb_sendbuff[20];  unsigned int i,cnt=0,address,lenth;    
  address=mbRxData[2];  address<<=8;  address|=mbRxData[3];
  lenth=mbRxData[4];    lenth<<=8;    lenth|=mbRxData[5];  
  if(address>=MB_BitDataSPACE) return;
  if(lenth>=MB_BitDataSPACE) return;
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;          // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];   // Funtion Code 
  mb_sendbuff[2]=(unsigned char)(lenth/8);  // Byte Count
  if(lenth%8)  mb_sendbuff[2]+=1;
  cnt=3; 
  for(i=0; i<mb_sendbuff[2]; i++){        // Data
    mb_sendbuff[cnt++]=(unsigned char)mb_UCdata[i+(address-MB_RxAdrOFFSET)];  
  }  
  GetCRC(mb_sendbuff,cnt,&mb_sendbuff[cnt], &mb_sendbuff[cnt+1]); cnt+=2;   // CRC  
  for(i=0; i<cnt; i++){  MB_ByteSend(mb_sendbuff[i]);   }  
  Rs485Ctr(0); 
}

void MBR_F5_BitWrite(void){
  unsigned char mb_sendbuff[10];  unsigned int i,address;    
  address=mbRxData[2];  address<<=8;  address|=mbRxData[3];
  if(address>=MB_BitDataSPACE) return;  
  if(mbRxData[4]==0xff)  mb_UCdata[address/8]|=BitOnVal[address%8];
  else   mb_UCdata[address/8]&=~BitOnVal[address%8];
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;              // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];       // Funtion Code 
  mb_sendbuff[2]=mbRxData[2];       // Start Address Hi
  mb_sendbuff[3]=mbRxData[3];       // Start Address Low
  mb_sendbuff[4]=mbRxData[4];;      // Data Hi
  mb_sendbuff[5]=mbRxData[5];       // Data Low  
  GetCRC(mb_sendbuff,6,&mb_sendbuff[6], &mb_sendbuff[7]);  // CRC
  for(i=0; i<8; i++){  MB_ByteSend(mb_sendbuff[i]);   }
  Rs485Ctr(0);   
}

/*void MBR_F15_BitMtWrite(void){
  unsigned char mb_sendbuff[10];  unsigned int i,address;    
  address=mbRxData[2];   address<<=8;  address|=mbRxData[3];
  if(address>=MB_BitDataSPACE) return;
  
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;               // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];              // Funtion Code
  mb_sendbuff[2]=mbRxData[2];  // Start Address Hi
  mb_sendbuff[3]=mbRxData[3];       // Start Address Low
  mb_sendbuff[4]=mbRxData[4];    // Lenth Hi
  mb_sendbuff[5]=mbRxData[5];         // Lenth Low  
  GetCRC(mb_sendbuff,6,&mb_sendbuff[6], &mb_sendbuff[7]);  // CRC
  for(i=0; i<8; i++){  MB_ByteSend(mb_sendbuff[i]);   }    
  Rs485Ctr(0); 
}*/


// WORD
void MBR_F3_WordRead(void){
  unsigned char mb_sendbuff[100];  unsigned int i,cnt=0,address,lenth;    
  address=mbRxData[2];  address<<=8;  address|=mbRxData[3];
  lenth=mbRxData[4];    lenth<<=8;    lenth|=mbRxData[5];  
  if(address>=MB_WordDataSPACE) return;
  if(lenth>=MB_WordDataSPACE) return;
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;            // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];     // Funtion Code 
  mb_sendbuff[2]=(unsigned char)(lenth*2);    // Byte Count
  cnt=3; 
  for(i=0; i<lenth; i++){          // Data
    mb_sendbuff[cnt]=(unsigned char)(mb_UIdata[i+(address-MB_RxAdrOFFSET)]>>8);
    mb_sendbuff[cnt+1]=(unsigned char)mb_UIdata[i+(address-MB_RxAdrOFFSET)];  
    cnt += 2;
  }  
  GetCRC(mb_sendbuff,cnt,&mb_sendbuff[cnt], &mb_sendbuff[cnt+1]); cnt += 2;   // CRC  
  for(i=0; i<cnt; i++){  MB_ByteSend(mb_sendbuff[i]);   }  
  Rs485Ctr(0);   
}

void MBR_F6_WordWrite(void){
  unsigned char mb_sendbuff[100];  unsigned int i,address,data;    
  address=mbRxData[2];  address<<=8;  address|=mbRxData[3];
  data=mbRxData[4];     data<<=8;     data|=mbRxData[5];
  if(address>=MB_WordDataSPACE) return;
  mb_UIdata[address]=data;
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;              // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];       // Funtion Code 
  mb_sendbuff[2]=mbRxData[2];       // Start Address Hi
  mb_sendbuff[3]=mbRxData[3];       // Start Address Low
  mb_sendbuff[4]=mbRxData[4];;      // Data Hi
  mb_sendbuff[5]=mbRxData[5];       // Data Low  
  GetCRC(mb_sendbuff,6,&mb_sendbuff[6], &mb_sendbuff[7]);  // CRC
  for(i=0; i<8; i++){  MB_ByteSend(mb_sendbuff[i]);   }
  Rs485Ctr(0);  
}

void MBR_F16_WordMtWrtie(void){
  unsigned char mb_sendbuff[100];  unsigned int i,address,lenth,data;    
  address=mbRxData[2];  address<<=8;  address|=mbRxData[3];
  lenth=mbRxData[4];    lenth<<=8;    lenth|=mbRxData[5];  
  if(address>=MB_WordDataSPACE) return;
  for(i=0; i<lenth; i++){
    data=mbRxData[7+(i*2)];     data<<=8;     data|=mbRxData[8+(i*2)];
    mb_UIdata[i+address]=data;
  }
  Rs485Ctr(1);
  mb_sendbuff[0]=ComId;               // Slave Address ; ID
  mb_sendbuff[1]=mbRxData[1];        // Funtion Code
  mb_sendbuff[2]=mbRxData[2];        // Start Address Hi
  mb_sendbuff[3]=mbRxData[3];        // Start Address Low
  mb_sendbuff[4]=mbRxData[4];        // Lenth Hi
  mb_sendbuff[5]=mbRxData[5];        // Lenth Low  
  GetCRC(mb_sendbuff,6,&mb_sendbuff[6], &mb_sendbuff[7]);  // CRC
  for(i=0; i<8; i++){  MB_ByteSend(mb_sendbuff[i]);   }    
  Rs485Ctr(0); 
}


void MBR_RcvAck(void){
  if(mbframecprevent){     
    if(mbRxData[0]==ComId){   // Slave Address 
      switch(mbRxData[1]){   // Fution Code
        case 1:  case 2:  // bit Read
          if(RcvGetCRC(mbRxData,6, mbRxData[6], mbRxData[7])){  MBR_F1_BitRead();    }
          break;
        case 5:
          if(RcvGetCRC(mbRxData,6, mbRxData[6], mbRxData[7])){  MBR_F5_BitWrite();   }
          break;
        case 3:  case 4:  // Word Read
          if(RcvGetCRC(mbRxData,6, mbRxData[6], mbRxData[7])){  MBR_F3_WordRead();   }
          break;
        case 6:       // Word Write
          if(RcvGetCRC(mbRxData,6, mbRxData[6], mbRxData[7])){  MBR_F6_WordWrite();  }
          break;
        case 16:   //Multi Word Write
          if(RcvGetCRC(mbRxData,mbRxData[6]+7, mbRxData[7+mbRxData[6]], mbRxData[8+mbRxData[6]])){
             MBR_F16_WordMtWrtie();  
          } 
          break;
        default:  break;  
      }	
    }
    mbframecprevent=0;  mbRxCnt=0;  
  }
}

//rx  ͷƮ ȿ 
void MBR_RcvItr(unsigned char val){
  if((mbframecprevent==0)&&(mbrs485CtrState==0)){
    mbRxData[mbRxCnt++]=val;	  if(mbRxCnt>=MB_RxDataMAX) mbRxCnt=MB_RxDataMAX-1;
    mbframecprcnt=0;    
  }
}

//1msec Ÿ̸ ͷƮ ȿ 
void MBR_TimerItr(void){
  if(mbframecprcnt==MB_FrameINTERVAL)  mbframecprevent=1; 
  if(++mbframecprcnt>250)   mbframecprcnt=250; 
  if(mb485CtrCnt==5){ mbrs485CtrState=0;  MB_RS485Ctr(0);   } 
  if(++mb485CtrCnt>250)   mb485CtrCnt=250; 
  mbTickEvt=1;
}

//while ȿ 
unsigned int MBRLoopCnt=0;
void MBR_Loop(void){
  if(mbTickEvt){ mbTickEvt=0;
     if(++MBRLoopCnt>=300){ MBRLoopCnt=0;    MBR_DataSet();      }
  }
  MBR_RcvAck();
}





#endif	




