#include <iom128.h>
#include <ina90.h>
#include <avr_macros.h>

#include "Modbus.h"
#include "uart128.h"
  

void main(void){   
   init_sys();  
   MBR_DataInit();
   
	while(1){	
     MBR_Loop();	   
	}  
}


#pragma vector=USART1_RXC_vect
__interrupt void USART1_RXC_interrupt(void){
   MBR_RcvItr(UDR1);    
	UCSR1A |= 0x80;
}
   


#pragma vector=TIMER0_OVF_vect
__interrupt void TIMER0_OVF_interrupt(void){	
  TCNT0 = TCNT0_VALUE;	// 0.1mSec
  MBR_TimerItr();
}	 










